#pragma once

/* #if defined(CONFIG_CLOCK_CONTROL_NRF2)
#include <hal/nrf_lrcconf.h>
#endif */

#include <zephyr/kernel.h>
#include <nrfx_spim.h>

/* extern uint8_t read_resp[2];
extern const nrfx_spim_t spim_instance;
extern volatile bool spi_xfer_done; */

typedef struct {

    uint32_t pin_mosi; // Master output, slave input PIN
    uint32_t pin_miso; // Master input, slave output PIN
    uint32_t pin_sclk; // Clock PIN
    uint32_t pin_cs;   // Chip select PIN

    uint32_t freq;     // Clock frequency in Hz
} encoder_cfg_t;

typedef struct{
    const nrfx_spim_t spim_instance;// SPI instance

    const struct device * gpio_dev;

    uint32_t pin_cs;   // Chip select PIN

    volatile uint32_t* reg_spi_end; //Pointer to SPIM register

} encoder_t;

/**
 * Initialisation of the SPIM
 * 
 * @param cfg encoder configuration
 * @param inst encoder instance
 * 
 * @return 0 if successful
 */
int encoder_init(const encoder_cfg_t *cfg, encoder_t* inst);

/**
 * Executing cmd to encoder
 * 
 * @param inst encoder instance 
 * @param cmd command bytes to be sent to encoder
 * @param resp encoder response
 * 
 * @return 0 if successful
 */
int encoder_cmd(encoder_t* inst, const uint8_t cmd[2], uint8_t resp[2]);

/**
 * Resetting encoder
 * 
 * @param inst encoder instance
 * 
 * @return 0 if successful
 */
int encoder_reset(encoder_t* inst);
 
/**
 * Reading encoder Position 
 * 
 * @param inst encoder instance
 * @param pos bytes for reading encoder position 
 * 
 * @return 0 if successful
 */
int encoder_read_pos(encoder_t* inst,uint16_t *pos);

