#include "support.h"

#include <zephyr/drivers/gpio.h>
#include <zephyr/kernel.h>
#include <zephyr/devicetree.h>

#define NODE_LED_BLUE DT_NODELABEL(led0_blue)
#define NODE_LED_RED DT_NODELABEL(led0_red)
#define NODE_LED_GREEN DT_NODELABEL(led0_green)


// LED specification
const struct gpio_dt_spec led_blue = GPIO_DT_SPEC_GET(NODE_LED_BLUE, gpios);
const struct gpio_dt_spec led_red = GPIO_DT_SPEC_GET(NODE_LED_RED, gpios);
const struct gpio_dt_spec led_green = GPIO_DT_SPEC_GET(NODE_LED_GREEN, gpios);

int support_init(void){
    int err;

    // Initialize LEDs
    err = gpio_pin_configure_dt(&led_blue,GPIO_OUTPUT_INACTIVE);
    if(err)return err;
    err = gpio_pin_configure_dt(&led_red,GPIO_OUTPUT_INACTIVE);
    if(err)return err;
    err = gpio_pin_configure_dt(&led_green,GPIO_OUTPUT_INACTIVE);
    if(err)return err;


    
    return 0;
}

void set_led(led_t led, bool active){
    gpio_pin_set_dt((led==BLUE) ? &led_blue : ((led == GREEN) ? &led_green : &led_red), active ? 1 : 0);
}

void set_error(void){
    set_led(RED, true);
}